// ML674000 register and bit definitions.
//
// Copyright (c) 2005 Rowley Associates Limited.
//
// This file may be distributed under the terms of the License Agreement
// provided with this software.
//
// THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#ifndef ML674000_h
#define ML674000_h

#define IRQ (*(volatile unsigned long *)0x78000000)

#define IRQS (*(volatile unsigned long *)0x78000004)

#define FIQ (*(volatile unsigned long *)0x78000008)

#define FIQRAW (*(volatile unsigned long *)0x7800000C)

#define FIQEN (*(volatile unsigned long *)0x78000010)

#define IRN (*(volatile unsigned long *)0x78000014)

#define CIL (*(volatile unsigned long *)0x78000018)

#define ILC0 (*(volatile unsigned long *)0x78000020)

#define ILC1 (*(volatile unsigned long *)0x78000024)

#define CILCL (*(volatile unsigned long *)0x78000028)

#define CILE (*(volatile unsigned long *)0x7800002C)

#define BWC (*(volatile unsigned long *)0x78100000)

#define ROMAC (*(volatile unsigned long *)0x78100004)

#define RAMAC (*(volatile unsigned long *)0x78100008)

#define IO0AC (*(volatile unsigned long *)0x7810000C)

#define IO1AC (*(volatile unsigned long *)0x78100010)

#define DBWC (*(volatile unsigned long *)0x78180000)

#define DRMC (*(volatile unsigned long *)0x78180004)

#define DRPC (*(volatile unsigned long *)0x78180008)

#define SDMD (*(volatile unsigned long *)0x7818000C)

#define DCMD (*(volatile unsigned long *)0x78180010)

#define RFSH0 (*(volatile unsigned long *)0x78180014)

#define RDWC (*(volatile unsigned long *)0x78180018)

#define RFSH1 (*(volatile unsigned long *)0x7818001C)

#define DMAMOD (*(volatile unsigned long *)0x7BE00000)

#define DMASTA (*(volatile unsigned long *)0x7BE00004)

#define DMAINT (*(volatile unsigned long *)0x7BE00008)

#define DMACMSK0 (*(volatile unsigned long *)0x7BE00100)

#define DMACTMOD0 (*(volatile unsigned long *)0x7BE00104)

#define DMACSAD0 (*(volatile unsigned long *)0x7BE00108)

#define DMACDAD0 (*(volatile unsigned long *)0x7BE0010C)

#define DMACSIZ0 (*(volatile unsigned long *)0x7BE00110)

#define DMACCINT0 (*(volatile unsigned long *)0x7BE00114)

#define DMACMSK1 (*(volatile unsigned long *)0x7BE00200)

#define DMACTMOD1 (*(volatile unsigned long *)0x7BE00204)

#define DMACSAD1 (*(volatile unsigned long *)0x7BE00208)

#define DMACDAD1 (*(volatile unsigned long *)0x7BE0020C)

#define DMACSIZ1 (*(volatile unsigned long *)0x7BE00210)

#define DMACCINT1 (*(volatile unsigned long *)0x7BE00214)

#define IRCL (*(volatile unsigned long *)0x7BF00004)

#define IRQA (*(volatile unsigned long *)0x7BF00010)

#define IDM (*(volatile unsigned long *)0x7BF00014)

#define ILC (*(volatile unsigned long *)0x7BF00018)

#define ADCON0 (*(volatile unsigned short *)0xB6000000)

#define ADCON1 (*(volatile unsigned short *)0xB6000004)

#define ADCON2 (*(volatile unsigned short *)0xB6000008)

#define ADINT (*(volatile unsigned short *)0xB600000C)

#define ADFINT (*(volatile unsigned short *)0xB6000010)

#define ADR0 (*(volatile unsigned short *)0xB6000014)

#define ADR1 (*(volatile unsigned short *)0xB6000018)

#define ADR2 (*(volatile unsigned short *)0xB600001C)

#define ADR3 (*(volatile unsigned short *)0xB6000020)

#define ADR4 (*(volatile unsigned short *)0xB6000024)

#define ADR5 (*(volatile unsigned short *)0xB6000028)

#define ADR6 (*(volatile unsigned short *)0xB600002C)

#define ADR7 (*(volatile unsigned short *)0xB6000030)

#define GPCTL (*(volatile unsigned short *)0xB7000000)

#define BCKCTL (*(volatile unsigned short *)0xB7000004)

#define GPPOA (*(volatile unsigned short *)0xB7A00000)

#define GPPIA (*(volatile unsigned short *)0xB7A00004)

#define GPPMA (*(volatile unsigned short *)0xB7A00008)

#define GPIEA (*(volatile unsigned short *)0xB7A0000C)

#define GPIPA (*(volatile unsigned short *)0xB7A00010)

#define GPISA (*(volatile unsigned short *)0xB7A00014)

#define GPPOB (*(volatile unsigned short *)0xB7A00020)

#define GPPIB (*(volatile unsigned short *)0xB7A00024)

#define GPPMB (*(volatile unsigned short *)0xB7A00028)

#define GPIEB (*(volatile unsigned short *)0xB7A0002C)

#define GPIPB (*(volatile unsigned short *)0xB7A00030)

#define GPISB (*(volatile unsigned short *)0xB7A00034)

#define UARTDLL (*(volatile unsigned char *)0xB7B00000)

#define UARTRBR (*(volatile unsigned char *)0xB7B00000)

#define UARTTHR (*(volatile unsigned char *)0xB7B00000)

#define UARTDLM (*(volatile unsigned char *)0xB7B00004)

#define UARTIER (*(volatile unsigned char *)0xB7B00004)

#define UARTFCR (*(volatile unsigned char *)0xB7B00008)

#define UARTIIR (*(volatile unsigned char *)0xB7B00008)

#define UARTLCR (*(volatile unsigned char *)0xB7B0000C)

#define UARTMCR (*(volatile unsigned char *)0xB7B00010)

#define UARTLSR (*(volatile unsigned char *)0xB7B00014)

#define UARTMSR (*(volatile unsigned char *)0xB7B00018)

#define UARTSCR (*(volatile unsigned char *)0xB7B0001C)

#define PWR0 (*(volatile unsigned short *)0xB7D00000)

#define PWCY0 (*(volatile unsigned short *)0xB7D00004)

#define PWC0 (*(volatile unsigned short *)0xB7D00008)

#define PWCON0 (*(volatile unsigned short *)0xB7D0000C)

#define PWR1 (*(volatile unsigned short *)0xB7D00020)

#define PWCY1 (*(volatile unsigned short *)0xB7D00024)

#define PWC1 (*(volatile unsigned short *)0xB7D00028)

#define PWCON1 (*(volatile unsigned short *)0xB7D0002C)

#define PWINTSTS (*(volatile unsigned short *)0xB7D0003C)

#define WDTCON (*(volatile unsigned char *)0xB7E00000)

#define WDTBCON (*(volatile unsigned char *)0xB7E00004)

#define WDSTAT (*(volatile unsigned char *)0xB7E00014)

#define TIMECNTL0 (*(volatile unsigned short *)0xB7F00000)

#define TIMEBASE0 (*(volatile unsigned short *)0xB7F00004)

#define TIMECNT0 (*(volatile unsigned short *)0xB7F00008)

#define TIMECMP0 (*(volatile unsigned short *)0xB7F0000C)

#define TIMESTAT0 (*(volatile unsigned short *)0xB7F00010)

#define TIMECNTL1 (*(volatile unsigned short *)0xB7F00020)

#define TIMEBASE1 (*(volatile unsigned short *)0xB7F00024)

#define TIMECNT1 (*(volatile unsigned short *)0xB7F00028)

#define TIMECMP1 (*(volatile unsigned short *)0xB7F0002C)

#define TIMESTAT1 (*(volatile unsigned short *)0xB7F00030)

#define TIMECNTL2 (*(volatile unsigned short *)0xB7F00040)

#define TIMEBASE2 (*(volatile unsigned short *)0xB7F00044)

#define TIMECNT2 (*(volatile unsigned short *)0xB7F00048)

#define TIMECMP2 (*(volatile unsigned short *)0xB7F0004C)

#define TIMESTAT2 (*(volatile unsigned short *)0xB7F00050)

#define TIMECNTL3 (*(volatile unsigned short *)0xB7F00060)

#define TIMEBASE3 (*(volatile unsigned short *)0xB7F00064)

#define TIMECNT3 (*(volatile unsigned short *)0xB7F00068)

#define TIMECMP3 (*(volatile unsigned short *)0xB7F0006C)

#define TIMESTAT3 (*(volatile unsigned short *)0xB7F00070)

#define TIMECNTL4 (*(volatile unsigned short *)0xB7F00080)

#define TIMEBASE4 (*(volatile unsigned short *)0xB7F00084)

#define TIMECNT4 (*(volatile unsigned short *)0xB7F00088)

#define TIMECMP4 (*(volatile unsigned short *)0xB7F0008C)

#define TIMESTAT4 (*(volatile unsigned short *)0xB7F00090)

#define TIMECNTL5 (*(volatile unsigned short *)0xB7F000A0)

#define TIMEBASE5 (*(volatile unsigned short *)0xB7F000A4)

#define TIMECNT5 (*(volatile unsigned short *)0xB7F000A8)

#define TIMECMP5 (*(volatile unsigned short *)0xB7F000AC)

#define TIMESTAT5 (*(volatile unsigned short *)0xB7F000B0)

#define CLKSTP (*(volatile unsigned long *)0xB8000004)

#define CGBCNT0 (*(volatile unsigned long *)0xB8000008)

#define CKWT (*(volatile unsigned long *)0xB800000C)

#define RMPCON (*(volatile unsigned long *)0xB8000010)

#define TMEN (*(volatile unsigned long *)0xB8001004)

#define TMRLR (*(volatile unsigned long *)0xB8001008)

#define TMOVFR (*(volatile unsigned long *)0xB8001010)

#define SIOBUF (*(volatile unsigned long *)0xB8002000)

#define SIOSTA (*(volatile unsigned long *)0xB8002004)

#define SIOCON (*(volatile unsigned long *)0xB8002008)

#define SIOBCN (*(volatile unsigned long *)0xB800200C)

#define SIOBT (*(volatile unsigned long *)0xB8002014)

#define SIOTCN (*(volatile unsigned long *)0xB8002018)


#endif
